# DLE UserBox

![version](https://img.shields.io/badge/version-1.6.0-red.svg?style=flat-square "Version")
![DLE](https://img.shields.io/badge/DLE-12.0_--_13.x-green.svg?style=flat-square "DLE Version")
[![MIT License](https://img.shields.io/badge/license-MIT-blue.svg?style=flat-square)](https://github.com/dle-modules/DLE-UserBox/blob/master/LICENSE)
[![Documentation](https://img.shields.io/badge/Documentation-Link-blue.svg?style=flat-square)](https://readme.lazydev.pro/dle-userbox.html)

Простой модуль для вывода информации о любом пользователе в любом месте сайта на DLE 12.0 - 13.x

Понадобится, если нужно вывести ***не только аватар*** и с минимальной нагрузкой на сайт!
Модуль будет полезен тогда, когда нужно вывести информацию о каком-либо пользователе в произвольном месте сайта (В т.ч. вне шаблона полной новости).
Например кулинарным сайтам, где нужно вывести информацию об авторе рецепта непосредственно в рецепт или личным (коллективным) блогам. 

## Возможности

- Подключение одной строкой.
- Вывод данных из профиля пользователя в любом месте сайта, на основе логина пользователя или текущего пользователя.
- Вывод дополнительных полей профиля пользователя (выводятся только те, которые не являются личными).
- Возможность использовать собственные шаблоны для вывода информации.
- Возможность добавлять свои поля с таблицы _users.
- Для параметра this не используется запрос.
- Кеширование результата работы модуля. Возможность включить кэширование данных если в настройках оно не включено.

## Особенности

- **Одна обязательная переменная в строке подключения** - &userName. Именно через эту переменную модуль определяет для какого юзера выводить информацию.
- **Добавляет один запрос на каждого выводимого модулем пользователя, кроме когда выводимый пользователь совпадает с пользователем который вошел**. Т.е. если выводить информацию об авторе новости в кратких новостях и на главной странице сайта выводится 30 новостей, которые опубликовали 10 пользователей (по три новости каждый) - то модуль при первом обращении к странице добавит 10 запросов в БД, после чего данные будут браться уже из кеша (при включенном кешировании на сайте). Если на второй странице попадётся пользователь с первой страницы, то запрос в БД на этого пользователя делаться не будет. Если же пользователь видит информацию о самом себе, то запрос не выполняеться а берется с глобальной переменой.
- **Собственная папка с шаблонами**. Для удобства использования.
- **Модуль выводит следующие данные**:
- Ник пользователя
- E-mail пользователя
- ID пользователя
- Количество новостей и ссылка на все новости пользователя
- Количество комментариев и ссылка на все комментарии пользователя
- Группа пользователя (форматированный вывод с префиксами и суффиксами)
- Дата последнего входа
- Дата регистрации
- Поле «О Себе»
- Поле «Подпись»
- Аватар пользователя
- Полное имя пользователя
- Место жительства пользователя
- Забанен ли пользователь
- Дополнительные поля пользователя (выводятся только те, которые не являются личными)
- Можно добавлять свои ячейки с таблицы _users

## Установка

- Распаковать архив в корень сайта, при этом не забывайте переименовать папку THEME в соответствии с названием текущего шаблона сайта.
- В нужном месте любого шаблона сайта прописать: `{include file="engine/modules/userbox.php?&userName=login"}` где login - логин пользователя.
- Всё!

Примеры использования:
`{include file="engine/modules/userbox.php?&userName={login}"}` - пример вывода информации о пользователи в новости.

`{include file="engine/modules/userbox.php?&userName=this"}` - пример вывода информации о текущем пользователе.

## Переменные строки подключения
- `&template=mytemplate` - шаблон вывода. Шаблон должен находиться в папке userbox.
- `&fields=balance,buy` - дополнительные ячейки которые подтягивать с таблицы _users. Указывать через запятую.
- `&cache=y` - включить кэширование если в настройках системы оно не включено.
- `&cachePrefix=userbox` - префикс кэша, по-умолчанию userbox.
